/*
    test available memory and memory-speed/cpu
    
    GS1280: malloc=12GB 2.2GB/s # mem=128GB, 41GB in use (malloc+mmap), swap=eager_mode 36GB

 */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

main(){
    size_t  l1,l2,l3,l4,l5;
    char *m1,*m2;
    clock_t t1,t2;
    time_t  u1,u2;
    l2=sizeof(size_t);printf("sizeof(time_t)= %ld  =>  addressable= ",l2);
    if( l2<6 ) printf("%ldMB\n",1l<<(l2*8-20)); else
    if( l2<8 ) printf("%ldGB\n",1l<<(l2*8-30));
    else       printf("%ldTB\n",1l<<(l2*8-40));
    l2=1l<<(l2*8-20);
    for(l1=1l;l1<l2;l1<<=1){
        m1=malloc(l1*1024l*1024l);
        if(!m1)break;
        free((void *)m1);
    }   l5=l1;
    for(l3=0l;l1>0;l1>>=1){
        m1=malloc((l3 | l1)*1024l*1024l);
        if(m1){ l3|=l1; }
        free((void *)m1);
    }
    printf("maxmem= %luMB\nstarting speedtest ...\n",l3);
    for(l1=1l;l1<=l5;l1<<=1){
        m1=malloc(l1*1024l*1024l);
        if(!m1)break;
        {
          for(l2=0;l2<l1;l2++) memset(m1+l2*1024l*1024l,'\xAA',1024l*1024l);
          for(l2=0;l2<l1;l2++) memset(m1+l2*1024l*1024l,'\x55',1024l*1024l);
        }
        time(&u1);t1=clock();
        for(l4=0;l4<2*l5/l1;l4++)
        {
          for(l2=0;l2<l1;l2++) memset(m1+l2*1024l*1024l,'\xAA',1024l*1024l);
          for(l2=0;l2<l1;l2++) memset(m1+l2*1024l*1024l,'\x55',1024l*1024l);
        }
        t2=clock()-t1;time(&u2);u2-=u1;
        printf(" %4lu*%4luMB*2 clk= %lu clk/MB= %lu t= %lu MB/s= %lu\n",
          2*l5/l1,l1,t2,t2/(l5*2),u2,2*(2*l5)/u2);
        free((void *)m1);
    }
    printf("");
    return 0;} 
